<template>
    <f7-page 
        name="product" 
        @page:beforein="onPageBeforeIn"
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Iklan Saya">
            <f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">{{ currentCategory == 'Semua' ? currentCategory + ' Iklan' : 'Iklan ' + currentCategory }} </f7-nav-title>
            <f7-nav-right>
                <f7-link href="/products/create/" icon-f7="add" color="smoothgray" icon-only></f7-link>
            </f7-nav-right>
		</f7-navbar>
        <f7-block>
			<f7-toolbar tabbar scrollable position="top" no-shadow no-hairlines class="no-background" style="top:0;">
                <f7-link @click="handleMyProductCategory('semua')" :class="`gradient-box${slugify(currentCategory) == 'semua' ? ' tab-link-active' : ''}`">
					<span class="">Semua</span>									
				</f7-link>
				<f7-link @click="handleMyProductCategory('dipublikasikan')" :class="`gradient-box${slugify(currentCategory) == 'dipublikasikan' ? ' tab-link-active' : ''}`">
					<span class="">Dipublikasikan</span>									
				</f7-link>
                <f7-link @click="handleMyProductCategory('disimpan')" :class="`gradient-box${slugify(currentCategory) == 'disimpan' ? ' tab-link-active' : ''}`">
					<span class="">Disimpan</span>									
				</f7-link>
			</f7-toolbar>
		</f7-block>

        <f7-block v-if="!myProductLoading && myProducts.length > 0">
            <f7-card class="card-header-pic" v-for="(product, index) in myProducts" v-bind:key="index">
                <f7-link @click="showActionSheet($event, product)" href="#" class="display-block color-gray">
                    <f7-card class="header-pic">
                        <f7-card-header
                            v-if="product.medias.length > 0"
                            class="no-border"
                            valign="bottom"
                            :style="`background-image:url(${product.medias[0].url.medium})`"
                        >{{ product.title }}</f7-card-header>
                        <f7-card-header
                            v-else
                            class="no-border no-photo"
                            valign="bottom"
                            :style="`background-image:url(${require('../assets/no-photo.jpg')})`"
                        >{{ product.title }}</f7-card-header>
                        <f7-card-content>                        
                            <p>{{ product.description }}</p>
                        </f7-card-content>
                        <f7-card-footer>
                            <span>Rp. {{ product.price.format(0,0,'.',',') }}</span>
                            <f7-chip outline :text="product.category.name" color="green"></f7-chip>
                        </f7-card-footer>
                    </f7-card>
                </f7-link>
            </f7-card>
        </f7-block>
        <f7-block v-else-if="!myProductLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="remove_shopping_cart" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
        <f7-card
			v-if="myProductLoading"
			class="skeleton-text"
			title="Card Header"
			content="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit."
			footer="Card Footer"
		></f7-card>
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, truncate, slugify } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'Product',
	data(){
		return{
            myProductLoading: true,
            allowInfinite: true,
            showPreloader: true,
            currentCategory: 'Semua'
        };
	},
	computed: {
		...mapGetters('auth', ['user']),
        ...mapGetters('product', [
            'myProducts',
            'pagination'
        ])
    },
    methods: {
        dateFormat,
        truncate,
        slugify,
        convertAmpersand(text){
            return text.replace(/&amp;/g, '&');
        },
        getProducts(page, loadmore){
            const self = this;
            const app = self.$f7;

            let status = null;

            if(self.currentCategory == 'Disimpan'){
                status = 'draft';
            }else if(self.currentCategory == 'Dipublikasikan'){
                status = 'publish';
            }
            
			self.$store.dispatch('product/getProducts', {
                author: self.user.id,
                page: page,
                perpage: 25,
                pageName: 'my',
                loadmore: loadmore,
                status: status,
                only: 'id,title,slug,description,minorder,price,delivery_cost,discount,isdeliverable,isnegotiable,category.id,category.name,category.slug,created,updated,unit.id,unit.name,unit.symbol,author.id,author.profile.fullname,author.profile.store_name,author.profile.store_about,medias'
			}).then((response)=>{
                setTimeout(() => {
                    self.myProductLoading = false;
                    self.showPreloader = self.pagination.has_next;
                }, 100);
            });
        },
        onPageBeforeIn(){
            const self = this;
            self.getProducts(1, false);
        },
        onPageRefresh(e, done){
            const self = this;

            self.myProductLoading = true;

            self.getProducts(1, false);
            done();
        },
        showActionSheet(e, product){
            const self = this;
            const app = self.$f7;

            let buttons = [{
                text: product.title,
                label: true
            }, {
                text: 'Lihat',
                close: true,
                onClick: function(actions, e){
                    self.$f7router.navigate('/marketplace/product/'+product.id+'/', {
						ignoreCache: true
					});
                }
            }, {
                text: 'Ubah',
                close: true,
                onClick: function(actions, e){
                    self.$f7router.navigate('/products/edit/'+product.id+'/', {
						ignoreCache: true
					});
                }
            }, {
                text: 'Hapus',
                close: true,
                onClick: function(actions, e){
                    app.dialog.confirm('Anda yakin ingin menghapus barang/jasa ini?', function(){
                        app.preloader.show('green');
                        self.$store.dispatch('product/deleteProduct', {
                            id: product.id,
                            only: 'id,title,slug,description,minorder,price,delivery_cost,discount,isdeliverable,isnegotiable,category.id,category.name,category.slug,created,updated,unit.id,unit.name,unit.symbol,author.id,author.profile.fullname,author.profile.store_name,author.profile.store_about,medias'
                        }).then((response)=>{
                            app.preloader.hide();
                            self.$f7router.refreshPage();
                        });
                    });
                }
            }, {
                text: 'Batal',
                color: 'red',
                close: true
            }];

            let actionSheet = app.actions.create({
                buttons: buttons
            }).open();
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;

            setTimeout(()=>{
                if(self.pagination.has_next){
                    self.getProducts(self.pagination.page + 1, true);
                    self.allowInfinite = true;                 
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
        handleMyProductCategory(category){
			const self = this;
            const app = self.$f7;
            
            self.myProductLoading = true;
            
            if(category == 'disimpan'){
                self.currentCategory = 'Disimpan';
                self.status = 'draft';
            }else if(category == 'dipublikasikan'){
                self.status = 'publish';
                self.currentCategory = 'Dipublikasikan';
            }else{
                self.status = null;
                self.currentCategory = 'Semua';
            }

            self.$store.dispatch('product/resetProducts', {
                pageName: 'my'
            }).then(()=>{
                self.getProducts(1, false);
            });

            
		}
    }
}
</script>
<style scoped>
    .header-pic .card-header {
        height: 40vw;
        background-size: cover;
        background-position: center;
        color: #fff;
    }

    .header-pic .card-header.no-photo{
        background-size: 65%;
    }
    .header-pic .card-content-padding .date{
        color: #8e8e93;
    }
</style>
